﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    internal class Code2 // вариант 4
    {
        public void Code()
        {
            Console.WriteLine("Введите номер задачи: ");
            int num = Convert.ToInt32(Console.ReadLine());
            switch (num)
            {
                case 1: getOneTask(); break;
                case 2: getTwoTask(); break;
                case 3: getThreeTask(); break;
                case 4: getFourTask(); break;
                case 5: getFiveTask(); break;
            }
        }
        // задача 1
        static void getOneTask() // данная задача решена верно и в полном объеме.
                                 // Единственное что было исправлено, это удаление неиспользованных переменных.
        {
            Console.Write("Введите размерность массива: ");
            int n = Convert.ToInt32(Console.ReadLine());
            int[] arr = new int[n];
            Random rnd = new Random();
            for (int i = 0; i < arr.Length; i++)
            {
                arr[i] = rnd.Next(1, 100);
            }
            Console.WriteLine("Исходный массив: ");
            foreach (int item in arr)
            {
                Console.Write($"{item} ");
            }
            int odInd = 0, dvInd = 0;
            for (int i = 0; i < arr.Length; i++)
            {
                if (1 == Convert.ToString(arr[i]).Length)
                {
                    odInd = i;
                    break;
                }
            }
            for (int i = 0; i < arr.Length; i++)
            {
                if (2 == Convert.ToString(arr[i]).Length)
                {
                    dvInd = i;
                    break;
                }
            }
            int x;
            x = arr[odInd];
            arr[odInd] = arr[dvInd];
            arr[dvInd] = x;
            Console.WriteLine("\nИзмененный массив: ");
            foreach (int item in arr)
            {
                Console.Write($"{item} ");
            }
        }

        // задача 2
        static void getTwoTask() // в данной задаче неправильно использовались переменные n и m, были перепутаны строки со столбцами.
                                 // Это было выявлено путем запуска программы и ввода значений n и m. 
                                 // Также неправильно определяется код символа. Это было определено тем, что всегда по завершению программы выводился код символа 0.
        {
            Console.Write("Введите размерность по строкам: ");
            int n = Convert.ToInt32(Console.ReadLine());
            Console.Write("Введите размерность по столбцам: ");
            int m = Convert.ToInt32(Console.ReadLine());
            char[,] arr = new char[n, m];
            Random rnd = new Random();
            for (int i = 0; i < arr.GetLength(0); i++)
            {
                for (int j = 0; j < arr.GetLength(1); j++)
                {
                    arr[i, j] = (char)rnd.Next('A', 'Z');
                }
            }
            Console.WriteLine("Итоговая матрица: ");
            for (int i = 0; i < arr.GetLength(0); i++)
            {
                for (int j = 0; j < arr.GetLength(1); j++)
                {
                    Console.Write($"{arr[i, j]} ");
                }
                Console.WriteLine();
            }
            showMaxEvenCharID(arr);
        }

        static void showMaxEvenCharID(char[,] arr)
        {
            int min = int.MaxValue; // минимальное значение было использовано 0, и поэтому меньшее этого значения программа не могла найти код символа.
                                    // Поэтому этому параметру было задано максимальное значение.
                                    // Это было определно путём поэтапного прохода по строкам кода с помощью средств отладки.
            char ch = arr[0, 0];
            for (int i = 0; i < arr.GetLength(0); i++)
            {
                for (int j = 0; j < arr.GetLength(1); j++)
                {
                    if (min > Convert.ToInt32(arr[i, j]) && Convert.ToInt32(arr[i, j]) % 2 == 0)
                    {
                        min = Convert.ToInt32(arr[i, j]);
                        ch = arr[i, j];
                    }
                } 
            }
            Console.WriteLine($"Код буквы {ch} является наименьшим четным числом ({min})");
        }

        // задача 3
        static void getThreeTask() // данная задача решена верно и в полном объеме.
        {
            Console.Write("Введите строку: ");
            string stroka = Console.ReadLine();
            int maxSimb = stroka.Length;
            int podschetZap = 0;
            for (int i = 0; i < maxSimb; i++)
            {
                if (stroka[i] == ',')
                {
                    podschetZap = podschetZap + 1;
                }
            }
            stroka = solutionForThree(ref stroka);
            Console.WriteLine("Количество удалённых символов: " + podschetZap);
        }

        static string solutionForThree(ref string stroka)
        {
            stroka = stroka.Replace(",", "");
            Console.WriteLine("Итоговая строка: " + stroka);
            return stroka;
        }

        // задача 4
        static void getFourTask() // данная задача решена верно и в полном объеме.
        {
            Console.Write("Введите строку: ");
            string stroka = Console.ReadLine();
            stroka = solutionForFour(ref stroka);
            Console.Write("Итоговая строка: " + stroka);
        }
        static string solutionForFour(ref string stroka)
        {
            char[] probel = { ' ' };
            stroka = stroka.TrimStart(probel);
            stroka = stroka.TrimEnd(probel);
            stroka = stroka.Replace(" ", "*");
            return stroka;
        }
        // задача 5
        static void getFiveTask() // в данном коде отсутствует возможность повторного ввода пароля до момента пака пароль не будет подходящим.
                                  // Чтобы это исправить нужно воспользоваться цикл while и создать флаги для завершения и продолжения цикла
                                  // flag = false - означает, что цикл продолжается; flag = true - означает, что цикл завершился, и пароль подходит под все требования.
                                  // В условии определения предпоследнего элемента пароля используется неверная конструкция.
                                  // Чтобы определить предпоследний элемент нужно использовать < password[password.Length - 2] >.
        {
            bool flag = false;
            while (flag == false)
            {
                Console.Write("Введите пароль: ");
                string password = Console.ReadLine();
                if (password.Length >= 6)
                {
                    if (!(password.All(ch => char.IsNumber(ch) || char.IsUpper(ch)) || password.All(ch => char.IsNumber(ch) || char.IsLower(ch))))
                    {
                        if (!(password.All(ch => char.IsNumber(ch)) || password.All(ch => char.IsLetter(ch))))
                        {
                            bool simb = false; // создание булевой переменной для определения присутствия специального символа
                            for (int i = 0; i < password.Length; i++)
                            {
                                if ((password[i] == '@') || (password[i] == '!') || (password[i] == '#') || (password[i] == '$') || (password[i] == '%') || (password[i] == '^'))
                                {
                                    simb = true;
                                }
                            }
                            if (simb == true)
                            {
                                char predposledSimb = password[password.Length - 2]; // изменено с 1 на 2
                                if (char.IsNumber(predposledSimb))
                                {
                                    Console.WriteLine("Предпоследний символ не должен быть цифрой!");
                                    flag = false; // добавление флага, означающего, что пароль НЕ удовлетворяет условиям
                                }
                                else
                                {
                                    Console.WriteLine("Пароль надёжный!");
                                    flag = true; // добавление флага, означающего, что пароль удовлетворяет условиям
                                }
                            }
                            else
                            {
                                Console.WriteLine("Пароль не имеет спец. символов (@, !, #, $, %, ^)");
                                flag = false; // добавление флага, означающего, что пароль НЕ удовлетворяет условиям
                            }
                        }
                        else
                        {
                            Console.WriteLine("Пароль не имеет цифры");
                            flag = false; // добавление флага, означающего, что пароль НЕ удовлетворяет условиям
                        }
                    }
                    else
                    {
                        Console.WriteLine("Пароль не имеет прописной буквы");
                        flag = false; // добавление флага, означающего, что пароль НЕ удовлетворяет условиям
                    }
                }
                else
                {
                    Console.WriteLine("Пароль имеет длину менее 6 символов");
                    flag = false; // добавление флага, означающего, что пароль НЕ удовлетворяет условиям
                }    
            }
        }
    }
}